(function($, window, document) {
        let plateCurrentlyActive = false;
        // Check if the element is at the top of the screen
        function isElementAtTop(el) {
            //check if the windows is between 5px below the top and 50% of screen height above top
            return $(window).scrollTop() > $(el).offset().top - 5 && $(window).scrollTop() < $(el).offset().top + $( window ).height()/2;
        }
        // Show and hide functions
        function addShowClass(el) {
            return $(el).addClass('show');
        }
        function addScrolledClass(el) {
          return $(el).addClass('scrolled');
      }
        function removeShowClass(el) {
            return $(el).removeClass('show');
        }
        function removeScrolledClass(el) {
          return $(el).removeClass('scrolled');
      }

        // Get elements to show and hide
        function getSectionHeroElements() {
            // Wildcard selector to grab any element whose ID contains 'part'
            return $("[id*=part]").not(".scrolled, .vb-hero");
            //return $("#vb-sectionHero--1").not(".scrolled");
        }
        $('body').on('scroll', function(event) {
          //only do scrolljack plate at a time
          if(plateCurrentlyActive){
            return;
          }
            getSectionHeroElements().each(function() {
                // Check if the element is at the top of the screen
                if (isElementAtTop($(this))) {
                    var $targetEle = $(this);
                    //if so, position-fix it and start animating
                    $(this).css('position', 'fixed');
                    $(this).css('z-index', '9999');
                    plateCurrentlyActive = true;
                    addScrolledClass($targetEle);
                    addShowClass($targetEle);
                    //after two seconds, jump the scrollbar to the top of the next element, then un-fix the position.
                    //the reason I am using the next element here for offset math is because position:fixed removes current element from document flow
                    setTimeout(function() {
                      window.scrollTo({
                        // top: $targetEle.next().offset().top -parseInt($targetEle.next().css('margin-top').replace("px", "")),
                        left: 0,
                        behavior: 'instant',
                      });
                      $targetEle.css('position', 'relative');
                      $(this).css('z-index', '1000');
                      plateCurrentlyActive = false;
                  }, 2000);
                }
            });
        });

})(jQuery, window, document);